| OpenCV 4.3.0 Open Source Computer Vision

Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::DISOpticalFlow Class Referenceabstract
Video Analysis » Object Tracking

DIS optical flow algorithm. More...

`#include <opencv2/video/tracking.hpp>`

Inheritance diagram for cv::DISOpticalFlow:

## Public Types
enum | { PRESET_ULTRAFAST = 0, PRESET_FAST = 1, PRESET_MEDIUM = 2 }

## Public Member Functions
virtual int | getFinestScale () const =0
| Finest level of the Gaussian pyramid on which the flow is computed (zero level corresponds to the original image resolution). The final flow is obtained by bilinear upscaling. More...
virtual int | getGradientDescentIterations () const =0
| Maximum number of gradient descent iterations in the patch inverse search stage. Higher values may improve quality in some cases. More...
virtual int | getPatchSize () const =0
| Size of an image patch for matching (in pixels). Normally, default 8x8 patches work well enough in most cases. More...
virtual int | getPatchStride () const =0
| Stride between neighbor patches. Must be less than patch size. Lower values correspond to higher flow quality. More...
virtual bool | getUseMeanNormalization () const =0
| Whether to use mean-normalization of patches when computing patch distance. It is turned on by default as it typically provides a noticeable quality boost because of increased robustness to illumination variations. Turn it off if you are certain that your sequence doesn't contain any changes in illumination. More...
virtual bool | getUseSpatialPropagation () const =0
| Whether to use spatial propagation of good optical flow vectors. This option is turned on by default, as it tends to work better on average and can sometimes help recover from major errors introduced by the coarse-to-fine scheme employed by the DIS optical flow algorithm. Turning this option off can make the output flow field a bit smoother, however. More...
virtual float | getVariationalRefinementAlpha () const =0
| Weight of the smoothness term. More...
virtual float | getVariationalRefinementDelta () const =0
| Weight of the color constancy term. More...
virtual float | getVariationalRefinementGamma () const =0
| Weight of the gradient constancy term. More...
virtual int | getVariationalRefinementIterations () const =0
| Number of fixed point iterations of variational refinement per scale. Set to zero to disable variational refinement completely. Higher values will typically result in more smooth and high-quality flow. More...
virtual void | setFinestScale (int val)=0
| Finest level of the Gaussian pyramid on which the flow is computed (zero level corresponds to the original image resolution). The final flow is obtained by bilinear upscaling. More...
virtual void | setGradientDescentIterations (int val)=0
| Maximum number of gradient descent iterations in the patch inverse search stage. Higher values may improve quality in some cases. More...
virtual void | setPatchSize (int val)=0
| Size of an image patch for matching (in pixels). Normally, default 8x8 patches work well enough in most cases. More...
virtual void | setPatchStride (int val)=0
| Stride between neighbor patches. Must be less than patch size. Lower values correspond to higher flow quality. More...
virtual void | setUseMeanNormalization (bool val)=0
| Whether to use mean-normalization of patches when computing patch distance. It is turned on by default as it typically provides a noticeable quality boost because of increased robustness to illumination variations. Turn it off if you are certain that your sequence doesn't contain any changes in illumination. More...
virtual void | setUseSpatialPropagation (bool val)=0
| Whether to use spatial propagation of good optical flow vectors. This option is turned on by default, as it tends to work better on average and can sometimes help recover from major errors introduced by the coarse-to-fine scheme employed by the DIS optical flow algorithm. Turning this option off can make the output flow field a bit smoother, however. More...
virtual void | setVariationalRefinementAlpha (float val)=0
| Weight of the smoothness term. More...
virtual void | setVariationalRefinementDelta (float val)=0
| Weight of the color constancy term. More...
virtual void | setVariationalRefinementGamma (float val)=0
| Weight of the gradient constancy term. More...
virtual void | setVariationalRefinementIterations (int val)=0
| Maximum number of gradient descent iterations in the patch inverse search stage. Higher values may improve quality in some cases. More...
Public Member Functions inherited from cv::DenseOpticalFlow
virtual void | calc (InputArray I0, InputArray I1, InputOutputArray flow)=0
| Calculates an optical flow. More...
virtual void | collectGarbage ()=0
| Releases all inner buffers. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< DISOpticalFlow > | create (int preset=DISOpticalFlow::PRESET_FAST)
| Creates an instance of DISOpticalFlow. More...
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

DIS optical flow algorithm.

This class implements the Dense Inverse Search (DIS) optical flow algorithm. More details about the algorithm can be found at [125] . Includes three presets with preselected parameters to provide reasonable trade-off between speed and quality. However, even the slowest preset is still relatively fast, use DeepFlow if you need better quality and don't care about speed.

This implementation includes several additional features compared to the algorithm described in the paper, including spatial propagation of flow vectors (getUseSpatialPropagation), as well as an option to utilize an initial flow approximation passed to calc (which is, essentially, temporal propagation, if the previous frame's flow field is passed).

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
PRESET_ULTRAFAST |
PRESET_FAST |
PRESET_MEDIUM |

## Member Function Documentation

## ◆ create()

static Ptr<DISOpticalFlow> cv::DISOpticalFlow::create | ( | int | preset = `DISOpticalFlow::PRESET_FAST` | ) |
| static

Python:
| retval | = | cv.DISOpticalFlow_create( | [, preset] | )

Creates an instance of DISOpticalFlow.

Parameters

  preset | one of PRESET_ULTRAFAST, PRESET_FAST and PRESET_MEDIUM

## ◆ getFinestScale()

virtual int cv::DISOpticalFlow::getFinestScale | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getFinestScale( |  | )

Finest level of the Gaussian pyramid on which the flow is computed (zero level corresponds to the original image resolution). The final flow is obtained by bilinear upscaling.

See also
  setFinestScale

## ◆ getGradientDescentIterations()

virtual int cv::DISOpticalFlow::getGradientDescentIterations | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getGradientDescentIterations( |  | )

Maximum number of gradient descent iterations in the patch inverse search stage. Higher values may improve quality in some cases.

See also
  setGradientDescentIterations

## ◆ getPatchSize()

virtual int cv::DISOpticalFlow::getPatchSize | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getPatchSize( |  | )

Size of an image patch for matching (in pixels). Normally, default 8x8 patches work well enough in most cases.

See also
  setPatchSize

## ◆ getPatchStride()

virtual int cv::DISOpticalFlow::getPatchStride | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getPatchStride( |  | )

Stride between neighbor patches. Must be less than patch size. Lower values correspond to higher flow quality.

See also
  setPatchStride

## ◆ getUseMeanNormalization()

virtual bool cv::DISOpticalFlow::getUseMeanNormalization | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getUseMeanNormalization( |  | )

Whether to use mean-normalization of patches when computing patch distance. It is turned on by default as it typically provides a noticeable quality boost because of increased robustness to illumination variations. Turn it off if you are certain that your sequence doesn't contain any changes in illumination.

See also
  setUseMeanNormalization

## ◆ getUseSpatialPropagation()

virtual bool cv::DISOpticalFlow::getUseSpatialPropagation | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getUseSpatialPropagation( |  | )

Whether to use spatial propagation of good optical flow vectors. This option is turned on by default, as it tends to work better on average and can sometimes help recover from major errors introduced by the coarse-to-fine scheme employed by the DIS optical flow algorithm. Turning this option off can make the output flow field a bit smoother, however.

See also
  setUseSpatialPropagation

## ◆ getVariationalRefinementAlpha()

virtual float cv::DISOpticalFlow::getVariationalRefinementAlpha | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getVariationalRefinementAlpha( |  | )

Weight of the smoothness term.

See also
  setVariationalRefinementAlpha

## ◆ getVariationalRefinementDelta()

virtual float cv::DISOpticalFlow::getVariationalRefinementDelta | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getVariationalRefinementDelta( |  | )

Weight of the color constancy term.

See also
  setVariationalRefinementDelta

## ◆ getVariationalRefinementGamma()

virtual float cv::DISOpticalFlow::getVariationalRefinementGamma | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getVariationalRefinementGamma( |  | )

Weight of the gradient constancy term.

See also
  setVariationalRefinementGamma

## ◆ getVariationalRefinementIterations()

virtual int cv::DISOpticalFlow::getVariationalRefinementIterations | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.DISOpticalFlow.getVariationalRefinementIterations( |  | )

Number of fixed point iterations of variational refinement per scale. Set to zero to disable variational refinement completely. Higher values will typically result in more smooth and high-quality flow.

See also
  setGradientDescentIterations

## ◆ setFinestScale()

virtual void cv::DISOpticalFlow::setFinestScale | ( | int | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setFinestScale( | val | )

Finest level of the Gaussian pyramid on which the flow is computed (zero level corresponds to the original image resolution). The final flow is obtained by bilinear upscaling.

See also
  getFinestScale

## ◆ setGradientDescentIterations()

virtual void cv::DISOpticalFlow::setGradientDescentIterations | ( | int | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setGradientDescentIterations( | val | )

Maximum number of gradient descent iterations in the patch inverse search stage. Higher values may improve quality in some cases.

See also
  getGradientDescentIterations

## ◆ setPatchSize()

virtual void cv::DISOpticalFlow::setPatchSize | ( | int | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setPatchSize( | val | )

Size of an image patch for matching (in pixels). Normally, default 8x8 patches work well enough in most cases.

See also
  getPatchSize

## ◆ setPatchStride()

virtual void cv::DISOpticalFlow::setPatchStride | ( | int | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setPatchStride( | val | )

Stride between neighbor patches. Must be less than patch size. Lower values correspond to higher flow quality.

See also
  getPatchStride

## ◆ setUseMeanNormalization()

virtual void cv::DISOpticalFlow::setUseMeanNormalization | ( | bool | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setUseMeanNormalization( | val | )

Whether to use mean-normalization of patches when computing patch distance. It is turned on by default as it typically provides a noticeable quality boost because of increased robustness to illumination variations. Turn it off if you are certain that your sequence doesn't contain any changes in illumination.

See also
  getUseMeanNormalization

## ◆ setUseSpatialPropagation()

virtual void cv::DISOpticalFlow::setUseSpatialPropagation | ( | bool | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setUseSpatialPropagation( | val | )

Whether to use spatial propagation of good optical flow vectors. This option is turned on by default, as it tends to work better on average and can sometimes help recover from major errors introduced by the coarse-to-fine scheme employed by the DIS optical flow algorithm. Turning this option off can make the output flow field a bit smoother, however.

See also
  getUseSpatialPropagation

## ◆ setVariationalRefinementAlpha()

virtual void cv::DISOpticalFlow::setVariationalRefinementAlpha | ( | float | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setVariationalRefinementAlpha( | val | )

Weight of the smoothness term.

See also
  getVariationalRefinementAlpha

## ◆ setVariationalRefinementDelta()

virtual void cv::DISOpticalFlow::setVariationalRefinementDelta | ( | float | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setVariationalRefinementDelta( | val | )

Weight of the color constancy term.

See also
  getVariationalRefinementDelta

## ◆ setVariationalRefinementGamma()

virtual void cv::DISOpticalFlow::setVariationalRefinementGamma | ( | float | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setVariationalRefinementGamma( | val | )

Weight of the gradient constancy term.

See also
  getVariationalRefinementGamma

## ◆ setVariationalRefinementIterations()

virtual void cv::DISOpticalFlow::setVariationalRefinementIterations | ( | int | val | ) |
| pure virtual

Python:
| None | = | cv.DISOpticalFlow.setVariationalRefinementIterations( | val | )

Maximum number of gradient descent iterations in the patch inverse search stage. Higher values may improve quality in some cases.

See also
  getGradientDescentIterations

The documentation for this class was generated from the following file:

- opencv2/video/tracking.hpp